jit.on()
fpsGraph = require "FPSGraph"

function love.load()
   thread = love.thread.newThread("thread.lua")
   channel = love.thread.getChannel("test")
   thread:start()
   i = {}
   i[1]='thread 1 is work'
   
   thread2 = love.thread.newThread("thread2.lua")
   channel2 = love.thread.getChannel("test2")
   thread2:start()
   i2 = {}
   i2[1]='thread 2 is work'
   
   thread3 = love.thread.newThread("thread3.lua")
   channel3 = love.thread.getChannel("test3")
   thread3:start()
   i3 = {}
   i3[1]='thread 3 is work'
   
   thread4 = love.thread.newThread("thread4.lua")
   channel4 = love.thread.getChannel("test4")
   thread4:start()
   i4 = {}
   i4[1]='thread 4 is work'
   
	-- graphs
	graphFPS = fpsGraph.createGraph(0, 0, love.graphics.getWidth())
	graphMemory = fpsGraph.createGraph(0, 50, love.graphics.getWidth(), 30)
	graphTimeDelta = fpsGraph.createGraph(0, 100, love.graphics.getWidth(), 30)
end

function love.keypressed( key, scancode, isrepeat )
	if key == 'escape' then
--		love.system.vibrate(3)
--		love.event.wait(3)
		
		love.event.quit()
--		love.event.push('quit')
	end
end

function love.update(dt)
   v = channel:pop()
   if v then
	  i[1]=v
   end
   
   v2 = channel2:pop()
   if v2 then
	  i2[1]=v2
   end
   
   v3 = channel3:pop()
   if v3 then
	  i3[1]=v3
   end
   
   v4 = channel4:pop()
   if v4 then
	  i4[1]=v4
   end
   
	-- graphs   
	fpsGraph.updateFPS(graphFPS, dt)
	fpsGraph.updateMem(graphMemory, dt)
	fpsGraph.updateGraph(graphTimeDelta, dt*10000, string.format('time delta sec: %.4f', dt), dt)
	   
end
function love.draw()
--   love.graphics.scale(1 / 0.2, 1 / 0.2)
   love.graphics.print(tostring(i[1]), 10, 250+10)
   love.graphics.print(tostring(i2[1]), 10, 250+20)
   love.graphics.print(tostring(i3[1]), 10, 250+30)
   love.graphics.print(tostring(i4[1]), 10, 250+40)
   
	-- graphs
	fpsGraph.drawGraphs({graphFPS, graphMemory, graphTimeDelta})
	
	love.graphics.print('app running in seconds = '..os.clock(), 5, 160)
	love.graphics.print('OperationSystem = '..love.system.getOS().."; ".._VERSION.."; "..jit.version.."("..jit.arch..")".."; LuaJIT on = "..tostring(jit.status()), 5, 180)
	local name, version, vendor, device = love.graphics.getRendererInfo()
	love.graphics.print(string.format("RendererInfo: name = %s, version = %s, vendor = %s, device = %s", name, version, vendor, device), 5, 200)
	love.graphics.print('ProcessorCount = '..love.system.getProcessorCount(), 5, 220)
end